#!/system/bin/sh

source="SOURCE"
target="TARGET"

# Check if the source exists
if [ ! -e "$source" ]; then
  echo "Source file/directory does not exist: $source"
  exit 1
fi

# Check if the target exists and is a directory
if [ ! -d "$target" ]; then
  # If the target doesn't exist or is a file, get its parent directory
  target_parent="$(dirname "$target")"

  # Create the parent directory if it doesn't exist
  if [ ! -d "$target_parent" ]; then
    mkdir -p "$target_parent"
  fi
fi

# Move the source to the target
if [ -f $source ]; then
    cp -rf "$source" "$target/"
else
    cp -rf "$source/." "$target/"
fi

# Check if the move was successful
if [ "$?" -eq 0 ]; then
  echo "Move successful: $source to $target ✅"
else
  echo "Move failed: $source to $target ❌"
fi