THEMES_PKG="com.bbk.theme"
THEMES_PATH="/sdcard/Android/data/com.bbk.theme/files/.dwd/c/o/m/b/b/k/t/h/e/m/e"

# Get the APK path
apk_path=$(pm path "$THEMES_PKG" | sed 's/package://')
backup_path="/sdcard/themes.apk"

if [ ! -z "$apk_path" ]; then
    cp "$apk_path" "$backup_path"
    echo "- Backup ✅"
else
    echo "- Backup ❎"
fi

run_silently() {
  $("$@" > /dev/null 2>&1)
}

kill_app(){
  echo "- Kill Themes ℹ️"
  run_silently pm uninstall --user 0 "$THEMES_PKG"
  run_silently pm uninstall "$THEMES_PKG"
  run_silently pm clear "$THEMES_PKG"
  run_silently am force-stop "$THEMES_PKG"
  run_silently service call package 131 s16 "$THEMES_PKG" i32 0 i32 0
  run_silently service call package 132 s16 "$THEMES_PKG" i32 0 i32 0
  run_silently service call package 133 s16 "$THEMES_PKG" i32 0 i32 0
  run_silently service call package 134 s16 "$THEMES_PKG" i32 0 i32 0
}

install(){
  echo "- Install APK ℹ️"
  echo -n "- "
  if [ -f "$backup_path" ]; then
    APK_SIZE=$(stat -c "%s" "$1")
    cat $1 | pm install -r -d -g -S $APK_SIZE
  else
    cmd package install-existing --user 0 $THEMES_PKG
  fi
}

action(){
  # toggle screen if off
  (dumpsys display | grep mScreenState=OFF > /dev/null) && input keyevent 26
  kill_app
  install $backup_path
  run_silently monkey -p com.bbk.theme -v 10
}

# Run at least
action

# Check
count=0
while [ ! -d "$THEMES_PATH" ]; do
  echo ""
  ((count += 1))
  echo "- Try again [$count]"
  action
  sleep 5  # Adjust the sleep duration as needed
done
echo "- Ready!!!"